Bug 522259 - yum update is failing with nss and/or glibc update
Summary: yum update is failing with nss and/or glibc update
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: yum
Version: 11
Hardware: i686
OS: Linux
low
high
Target Milestone: ---
Assignee: Seth Vidal
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 512181 519254 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-09-09 22:02 UTC by Neil
Modified: 2014-01-21 23:11 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-04-29 18:22:03 UTC


Attachments (Terms of Use)

Description Neil 2009-09-09 22:02:36 UTC
Description of problem:

Experienced with attempted update of packages nss and nss-softokn-freebl for several weeks (I can live with this) but today's update of glibc is now causing the same problem.

When running 'yum update' after logging in as root (with 'su -' in a regular xterm or gnome terminal I receive a python script error.

I've been able to avoid the problem by updating packages individually by name - but nss has failed to update consistently since early August.  Now glibc update is generating the same error.

My computer also experiences the problem with desktop updates (probably yum-updatesd?), I've worked around the problem here by showing the updates and unticking anything beginning with nss.

Version-Release number of selected component (if applicable):

[root@clive ~]# uname -a
Linux clive.******.org 2.6.30.5-43.fc11.i586 #1 SMP Thu Aug 27 21:18:54 EDT 2009 i686 i686 i386 GNU/Linux

[root@clive ~]# rpm -qa|grep yum
yumex-2.0.5-6.fc11.noarch
PackageKit-yum-plugin-0.4.9-1.fc11.i586
yum-updatesd-0.9-2.fc11.noarch
PackageKit-yum-0.4.9-1.fc11.i586
yum-plugin-remove-with-leaves-1.1.22-1.fc11.noarch
yum-3.2.23-3.fc11.noarch
yum-presto-0.5.0-1.fc11.noarch
anaconda-yum-plugins-1.0-4.fc11.noarch
yum-metadata-parser-1.1.2-12.fc11.i586
yum-plugin-keys-1.1.22-1.fc11.noarch
yum-utils-1.1.22-1.fc11.noarch
yum-plugin-protectbase-1.1.22-1.fc11.noarch


How reproducible:

Every time I run updates.

Steps to Reproduce:
1. Open an xterm
2. use 'su -' to get to the root account 
3. run 'yum -y update'
  
Actual results:

I get this in the package update tool:

----
Traceback (most recent call last):
  File "/usr/share/PackageKit/helpers/yum/yumBackend.py", line 1251, in _get_depends_not_installed
    txmbrs = self.yumbase.install(po=pkg)
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2691, in install
    txmbrs = self.update(po=po)
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2965, in update
    updated_pkg =  self.rpmdb.searchPkgTuple(updated)[0]
IndexError: list index out of range
----

and this when running the update from the command line:

----
[root@clive ~]# yum -y update
Loaded plugins: keys, presto, protectbase, refresh-packagekit, remove-with-
              : leaves
0 packages excluded due to repository protections
Setting up Update Process
Traceback (most recent call last):
  File "/usr/bin/yum", line 29, in <module>
    yummain.user_main(sys.argv[1:], exit_code=True)
  File "/usr/share/yum-cli/yummain.py", line 309, in user_main
    errcode = main(args)
  File "/usr/share/yum-cli/yummain.py", line 178, in main
    result, resultmsgs = base.doCommands()
  File "/usr/share/yum-cli/cli.py", line 352, in doCommands
    return self.yum_cli_commands[self.basecmd].doCommand(self, self.basecmd, self.extcmds)
  File "/usr/share/yum-cli/yumcommands.py", line 201, in doCommand
    return base.updatePkgs(extcmds)
  File "/usr/share/yum-cli/cli.py", line 608, in updatePkgs
    self.update()
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2829, in update
    tx_return.extend(self.update(po=self.getPackageObject(new)))
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2965, in update
    updated_pkg =  self.rpmdb.searchPkgTuple(updated)[0]
IndexError: list index out of range
----

Expected results:

I expect to see the updates complete cleanly.

Additional info:

Hardware is an Asus Eee PC 901 with solid state drives, Fedora is installed on a brand new (<2 months old) 16Gb SDHC card.

Comment 1 seth vidal 2009-09-10 20:30:54 UTC
You can make this happen everytime? B/c adding some debug info here would really help me out solving this.

Comment 2 seth vidal 2009-09-15 16:41:16 UTC
ping, please. I could use some help making this happen.

Comment 3 James Antill 2009-09-17 04:34:30 UTC
When I've seen this there is usually something wrong with the local rpmdb (the error is that one part of yum thinks pkgA is installed while another can't find it), try running:

package-cleanup --problems
package-cleanup --dupes
rpm -Va --nofiles --nodigest

...and providing those results.

Comment 4 Neil 2009-09-17 19:25:18 UTC
Hi Seth.  To get some kind of debug output I've run 'yum -v update', here's the results:

----
[root@clive ~]# yum -v update
Not loading "blacklist" plugin, as it is disabled
Loading "keys" plugin
Loading "presto" plugin
Loading "protectbase" plugin
Loading "refresh-packagekit" plugin
Loading "remove-with-leaves" plugin
Not loading "whiteout" plugin, as it is disabled
Config time: 0.624
Yum Version: 3.2.23
Setting up Package Sacks
0 packages excluded due to repository protections
pkgsack time: 0.063
rpmdb time: 0.121
Setting up Update Process
Updating Everything
Building updates object
up:Obs Init time: 0.912
up:simple updates time: 1.112
up:obs time: 0.059
up:condense time: 0.000
updates time: 12.692
Traceback (most recent call last):
  File "/usr/bin/yum", line 29, in <module>
    yummain.user_main(sys.argv[1:], exit_code=True)
  File "/usr/share/yum-cli/yummain.py", line 309, in user_main
    errcode = main(args)
  File "/usr/share/yum-cli/yummain.py", line 178, in main
    result, resultmsgs = base.doCommands()
  File "/usr/share/yum-cli/cli.py", line 352, in doCommands
    return self.yum_cli_commands[self.basecmd].doCommand(self, self.basecmd, self.extcmds)
  File "/usr/share/yum-cli/yumcommands.py", line 201, in doCommand
    return base.updatePkgs(extcmds)
  File "/usr/share/yum-cli/cli.py", line 608, in updatePkgs
    self.update()
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2829, in update
    tx_return.extend(self.update(po=self.getPackageObject(new)))
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2965, in update
    updated_pkg =  self.rpmdb.searchPkgTuple(updated)[0]
IndexError: list index out of range
----

I don't think this provides much extra information.  I'm now going to run the commands suggested by James, I'll add the output from those next.

Comment 5 Neil 2009-09-17 19:27:38 UTC
[root@clive ~]# package-cleanup --problems
Setting up yum
Loaded plugins: presto, protectbase, refresh-packagekit, remove-with-leaves
0 packages excluded due to repository protections
0 packages excluded due to repository protections
Reading local RPM database
Processing all local requires
Missing dependencies:
Package nss-3.12.3.99.3-2.11.3.fc11.i586 requires nss-softokn-freebl(x86-32) >= 3.12.3.99.3
Package glibc-2.10.1-4.i686 requires libfreebl3.so
Package glibc-2.10.1-4.i686 requires libfreebl3.so(NSSRAWHASH_3.12.3)

Comment 6 Neil 2009-09-17 19:31:18 UTC
[root@clive ~]# package-cleanup --dupes
Setting up yum
Loaded plugins: presto, protectbase, refresh-packagekit, remove-with-leaves
0 packages excluded due to repository protections
0 packages excluded due to repository protections
Traceback (most recent call last):
  File "/usr/bin/package-cleanup", line 498, in <module>
    main()
  File "/usr/bin/package-cleanup", line 479, in main
    printDupes(my, opts.qf)
  File "/usr/bin/package-cleanup", line 185, in printDupes
    po = my.getInstalledPackageObject((n,a,e,v,r))
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2297, in getInstalledPackageObject
    po = self.rpmdb.searchPkgTuple(pkgtup)[0] # take the first one
IndexError: list index out of range
[root@clive ~]#

Comment 7 Neil 2009-09-17 19:37:29 UTC
[root@clive ~]# rpm -Va --nofiles --nodigest
Unsatisfied dependencies for nss-3.12.3.99.3-2.11.3.fc11.i586:
	nss-softokn-freebl(x86-32) >= 3.12.3.99.3 is needed by nss-3.12.3.99.3-2.11.3.fc11.i586
Unsatisfied dependencies for glibc-2.10.1-4.i686:
	libfreebl3.so is needed by glibc-2.10.1-4.i686
	libfreebl3.so(NSSRAWHASH_3.12.3) is needed by glibc-2.10.1-4.i686
[root@clive ~]# 


Again, I'm not sure how much extra information this provides, and I've no idea how this arose.  I'm a software engineer by profession, I'm quite prepared to run additional tools if necessary.

Comment 8 seth vidal 2009-09-17 19:39:25 UTC
How comfortable do you feel about modifying a file and rerunning some output?

b/c I'd love to know what  pkgtup is being looked for there that cannot be found.

Comment 9 Neil 2009-09-18 06:27:02 UTC
I added:

print 'pkgtup='
print pkgtup

at line 2297 in __init__.py and re-ran 'package-cleanup --dupes'

Here's the output it gave:

----
[root@clive ~]# package-cleanup --dupes
Setting up yum
Loaded plugins: presto, protectbase, refresh-packagekit, remove-with-leaves
0 packages excluded due to repository protections
0 packages excluded due to repository protections
pkgtup= 
('kernel', 'i586', '0', '2.6.30.5', '43.fc11')
pkgtup= 
('kernel', 'i586', '0', '2.6.29.6', '217.2.16.fc11')
pkgtup= 
('kernel', 'i586', '0', '2.6.29.6', '217.2.8.fc11')
pkgtup= 
('nss-softokn-freebl', 'i586', '0', '3.12.3.99.3', '2.11.3.fc11')
Traceback (most recent call last):
  File "/usr/bin/package-cleanup", line 498, in <module>
    main()
  File "/usr/bin/package-cleanup", line 479, in main
    printDupes(my, opts.qf)
  File "/usr/bin/package-cleanup", line 185, in printDupes
    po = my.getInstalledPackageObject((n,a,e,v,r))
  File "/usr/lib/python2.6/site-packages/yum/__init__.py", line 2300, in getInstalledPackageObject
    po = self.rpmdb.searchPkgTuple(pkgtup)[0] # take the first one
IndexError: list index out of range
[root@clive ~]# 
----

Comment 10 James Antill 2009-09-18 15:21:12 UTC
 So, yeh, you need to install these:

Missing dependencies:
Package nss-3.12.3.99.3-2.11.3.fc11.i586 requires nss-softokn-freebl(x86-32) >=
3.12.3.99.3
Package glibc-2.10.1-4.i686 requires libfreebl3.so
Package glibc-2.10.1-4.i686 requires libfreebl3.so(NSSRAWHASH_3.12.3) 

...esp. the first one, which is killing yum.
 That package isn't the latest in Fedora anymore, so you'll need to download it from http://kojipkgs.fedoraproject.org/packages/nss/3.12.3.99.3/2.11.3.fc11/i586/

Comment 11 Neil 2009-09-18 20:24:31 UTC
That has made the problem go away.  I installed nss-softokn-freebl from the link you posted.  I needed to do 'rpm --rebuilddb' to finally get it all working.

I wonder what actually failed?

Comment 12 Fedora Update System 2009-09-30 01:39:13 UTC
yum-3.2.24-2.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 13 seth vidal 2009-10-13 15:49:08 UTC
*** Bug 512181 has been marked as a duplicate of this bug. ***

Comment 14 seth vidal 2009-10-13 16:21:46 UTC
*** Bug 519254 has been marked as a duplicate of this bug. ***

Comment 15 Fedora Update System 2009-10-19 16:45:44 UTC
yum-3.2.24-2.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/yum-3.2.24-2.fc10

Comment 16 Fedora Update System 2009-11-04 12:06:31 UTC
yum-3.2.24-2.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 17 Juan P. Daza P. 2009-12-11 01:56:35 UTC
Thank you for taking the time to report this bug. Updates to this package have been released since it was first reported. If you have time to update the package and re-test, please do so and report the results here.

---

Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 18 Bug Zapper 2010-04-28 10:16:03 UTC
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping


Note You need to log in before you can comment on or make changes to this bug.